"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const build_angular_1 = require("@angular-devkit/build-angular");
const architect_1 = require("@angular-devkit/architect");
const build_plugin_1 = require("../build-plugin");
const rxjs_1 = require("rxjs");
const operators_1 = require("rxjs/operators");
function serveWebpackBrowserPlugin(options, context) {
    const browserTarget = architect_1.targetFromTargetString(options.browserTarget);
    return rxjs_1.from(context.getTargetOptions(browserTarget)).pipe(operators_1.switchMap(browserOptions => {
        options.plugin = options.plugin || browserOptions.plugin;
        build_plugin_1.loadPlugin(context.workspaceRoot, options);
        build_plugin_1.executeHook(build_plugin_1.PluginHook.PRE, context);
        const webpackConfiguration = config => build_plugin_1.executeHook(build_plugin_1.PluginHook.CONFIG, config);
        return build_angular_1.executeDevServerBuilder(options, context, { webpackConfiguration });
    }), operators_1.tap(() => build_plugin_1.executeHook(build_plugin_1.PluginHook.POST, context)));
}
exports.serveWebpackBrowserPlugin = serveWebpackBrowserPlugin;
exports.default = architect_1.createBuilder(serveWebpackBrowserPlugin);
