"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const build_angular_1 = require("@angular-devkit/build-angular");
const architect_1 = require("@angular-devkit/architect");
const build_plugin_1 = require("../build-plugin");
const operators_1 = require("rxjs/operators");
function buildWebpackServerPlugin(options, context) {
    build_plugin_1.loadPlugin(context.workspaceRoot, options);
    build_plugin_1.executeHook(build_plugin_1.PluginHook.PRE, context);
    const webpackConfiguration = config => build_plugin_1.executeHook(build_plugin_1.PluginHook.CONFIG, config);
    return build_angular_1.executeServerBuilder(options, context, { webpackConfiguration }).pipe(operators_1.tap(() => build_plugin_1.executeHook(build_plugin_1.PluginHook.POST, context)));
}
exports.buildWebpackServerPlugin = buildWebpackServerPlugin;
exports.default = architect_1.createBuilder(buildWebpackServerPlugin);
